'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }(); /**
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      * Plugin管理对象
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      * 提供插件统一调用的地方, 所有的插件都会被加载, 并且封装一个get方法来获取实例, 确保每一个插件都是单例.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      *
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      * PluginMap中定义了对外公开的插件名 和 对应的插件Class. 并且保存了插件的实例对象.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      *      插件对外公开的插件名都是本身类名去掉后缀Plugin , 然后再转成驼峰的结果.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      *      只有phone一个例外. 后期考虑将PhoneCallPlugin改名为PhonePlugin.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      *
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      * Created by TonyJiang on 16/4/28.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      */

var _chanjetPluginBase = require('chanjet-plugin-base');

var _chanjetPluginAuth = require('chanjet-plugin-auth');

var _chanjetPluginAuth2 = _interopRequireDefault(_chanjetPluginAuth);

var _chanjetPluginChoosePhoto = require('chanjet-plugin-choose-photo');

var _chanjetPluginChoosePhoto2 = _interopRequireDefault(_chanjetPluginChoosePhoto);

var _chanjetPluginTakePhoto = require('chanjet-plugin-take-photo');

var _chanjetPluginTakePhoto2 = _interopRequireDefault(_chanjetPluginTakePhoto);

var _chanjetPluginGeo = require('chanjet-plugin-geo');

var _chanjetPluginGeo2 = _interopRequireDefault(_chanjetPluginGeo);

var _chanjetPluginPhoneCall = require('chanjet-plugin-phone-call');

var _chanjetPluginPhoneCall2 = _interopRequireDefault(_chanjetPluginPhoneCall);

var _chanjetPluginPreview = require('chanjet-plugin-preview');

var _chanjetPluginPreview2 = _interopRequireDefault(_chanjetPluginPreview);

var _chanjetPluginRestoreStatus = require('chanjet-plugin-restore-status');

var _chanjetPluginRestoreStatus2 = _interopRequireDefault(_chanjetPluginRestoreStatus);

var _chanjetPluginShare = require('chanjet-plugin-share');

var _chanjetPluginShare2 = _interopRequireDefault(_chanjetPluginShare);

var _chanjetPluginSms = require('chanjet-plugin-sms');

var _chanjetPluginSms2 = _interopRequireDefault(_chanjetPluginSms);

var _chanjetPluginSpeechReco = require('chanjet-plugin-speech-reco');

var _chanjetPluginSpeechReco2 = _interopRequireDefault(_chanjetPluginSpeechReco);

var _chanjetPluginUpload = require('chanjet-plugin-upload');

var _chanjetPluginUpload2 = _interopRequireDefault(_chanjetPluginUpload);

var _chanjetPluginNavigation = require('chanjet-plugin-navigation');

var _chanjetPluginNavigation2 = _interopRequireDefault(_chanjetPluginNavigation);

var _chanjetPluginAlert = require('chanjet-plugin-alert');

var _chanjetPluginAlert2 = _interopRequireDefault(_chanjetPluginAlert);

var _chanjetPluginMember = require('chanjet-plugin-member');

var _chanjetPluginMember2 = _interopRequireDefault(_chanjetPluginMember);

var _chanjetPluginDatepicker = require('chanjet-plugin-datepicker');

var _chanjetPluginDatepicker2 = _interopRequireDefault(_chanjetPluginDatepicker);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

// import ScanCardPlugin from '../../chanjet-plugins/chanjet-plugin-scan-card/src';


// import ChoosePhotoPlugin from '../../chanjet-plugins/chanjet-plugin-choose-photo/src';
// import PreviewPlugin from '../../chanjet-plugins/chanjet-plugin-preview/src';
// import SpeechRecoPlugin from '../../chanjet-plugins/chanjet-plugin-speech-reco/src';
// import SharePlugin from '../../chanjet-plugins/chanjet-plugin-share/src';

var PluginMap = {
    //企业信息
    auth: {
        class: _chanjetPluginAuth2.default,
        instance: null
    },

    //选照片
    choosePhoto: {
        class: _chanjetPluginChoosePhoto2.default,
        instance: null
    },
    //拍照
    takePhoto: {
        class: _chanjetPluginTakePhoto2.default,
        instance: null
    },
    //预览
    preview: {
        class: _chanjetPluginPreview2.default,
        instance: null
    },
    //上传
    upload: {
        class: _chanjetPluginUpload2.default,
        instance: null
    },

    //定位
    geo: {
        class: _chanjetPluginGeo2.default,
        instance: null
    },

    //打电话
    phone: {
        class: _chanjetPluginPhoneCall2.default,
        instance: null
    },

    //短信
    sms: {
        class: _chanjetPluginSms2.default,
        instance: null
    },

    //分享
    share: {
        class: _chanjetPluginShare2.default,
        instance: null
    },

    //语音识别
    speechReco: {
        class: _chanjetPluginSpeechReco2.default,
        instance: null
    },

    //android restore状态查询
    restoreStatus: {
        class: _chanjetPluginRestoreStatus2.default,
        instance: null
    },

    alert: {
        class: _chanjetPluginAlert2.default,
        instance: null
    },

    navigation: {
        class: _chanjetPluginNavigation2.default,
        instance: null
    },

    member: {
        class: _chanjetPluginMember2.default,
        instance: null
    },

    datepicker: {
        class: _chanjetPluginDatepicker2.default,
        instance: null
    }

    // //名片扫描
    // scanCard : {
    //     class : ScanCardPlugin,
    //     instance : null
    // }
};

var PluginManager = function () {
    function PluginManager() {
        var _this = this;

        _classCallCheck(this, PluginManager);

        var _loop = function _loop(name) {
            Object.defineProperty(_this, name, {
                get: function get() {
                    if (!PluginMap[name].instance) {
                        PluginMap[name].instance = new PluginMap[name].class();
                    }
                    return PluginMap[name].instance;
                }
            });
        };

        //遍历所有插件,并提供getter方法
        for (var name in PluginMap) {
            _loop(name);
        }
    }

    /**
     * 设置mock数据
     * @param mockData
     */


    _createClass(PluginManager, [{
        key: 'setMockData',
        value: function setMockData(mockData) {
            _chanjetPluginBase.PluginMocker.data = mockData;
        }
    }]);

    return PluginManager;
}();

var instance = new PluginManager();

exports.default = instance;